#include <stdio.h>
#include <SDL/SDL.h>

int main(int argc, char *argv[]) {
    // Grafiksubsystem der SDL initialisieren
    if (SDL_Init(SDL_INIT_VIDEO) < 0) {
        printf("SDL konnte nicht initialisiert werden: %s\n", SDL_GetError());
        return 1;
    }

    // SDL bei Programmende automatisch schlieen lassen
    atexit(SDL_Quit);

    // Hintergrundgrafik laden
    SDL_Surface *background = SDL_LoadBMP("images/background.bmp");
    if (background == NULL) {
        printf("Fehler beim Laden von background.bmp: %s\n", SDL_GetError());
        return 1;
    }

    // Kreisgrafik laden
    SDL_Surface *circle = SDL_LoadBMP("images/circle.bmp");
    if (circle == NULL) {
        printf("Fehler beim Laden von circle.bmp: %s\n", SDL_GetError());
        return 1;
    }

    // grnen Hintergrund transparent machen
    SDL_SetColorKey(circle, SDL_SRCCOLORKEY, SDL_MapRGB(circle->format, 0x00,0xFF,0x00));

    // Fenster fr Grafikausgabe ffnen
    SDL_Surface *screen = SDL_SetVideoMode(350, 350, 32, SDL_SWSURFACE);
    if ( screen == NULL ) {
        printf("Fehler beim ffnen des Ausgabefensters: %s\n", SDL_GetError());
        return 1;
    }

    SDL_WM_SetCaption("Freitagsrunde presents: TicTacToe", NULL);

    // Hintergrund ins Fenster zeichnen
    SDL_BlitSurface(background, NULL, screen, NULL);
    SDL_Flip(screen);

    int quit = 0;
    SDL_Event event;
    SDL_Rect offset;

    // Event-Loop
    while (!quit) {
        // Event vorhanden?
        if (SDL_PollEvent(&event)) {
            switch (event.type) {

                // Mousebutton wurde gedrckt
                case SDL_MOUSEBUTTONDOWN:
                    offset.x = event.button.x;
                    offset.y = event.button.y;
                    SDL_BlitSurface(circle, NULL, screen, &offset);
                    SDL_Flip(screen);
                    break;

                case SDL_QUIT:
                    quit = 1;
                    break;
            }
        }
    }

    // Fenster schlieen
    SDL_FreeSurface(screen);

    return 0;
}
